#include <QtGui/QApplication>
#include "mainwindow.h"
#include "utils.h"
#include <QLocale>
#include <QTranslator>

int main(int argc, char *argv[])
{
	QApplication a(argc, argv);
	QApplication::setApplicationName("QMeshViewer");
	QApplication::setOrganizationName("zuzuf");

	const QStringList &args = a.arguments();
	QString load_filename;
	QString render_to_filename;
	int render_w = 160, render_h = 120;
	for(int i = 1 ; i < args.size() ; ++i)
	{
		if (args[i] == "-r")
		{
			++i;
			if (i < args.size())
				render_to_filename = args[i];
		}
		else if (args[i] == "-w")
		{
			++i;
			if (i < args.size())
				render_w = args[i].toUInt();
		}
		else if (args[i] == "-h")
		{
			++i;
			if (i < args.size())
				render_h = args[i].toUInt();
		}
		else
			load_filename = args[i];
	}

	if (!render_to_filename.isEmpty())
	{
		render_thumbnail(load_filename, render_to_filename, render_w, render_h);
		return 0;
	}

	const QString &locale_code = QLocale::system().name().left(2);

	QTranslator t_qt;
	t_qt.load(":/i18n/qt_" + locale_code + ".qm");
	a.installTranslator(&t_qt);
	QTranslator t_qmeshviewer;
	t_qmeshviewer.load(":/i18n/qmeshviewer_" + locale_code + ".qm");
	a.installTranslator(&t_qmeshviewer);

	MainWindow w;
	w.show();
	if (!load_filename.isEmpty())
		w.loadMesh(load_filename);

	return a.exec();
}
